<?php
############################################################################
require_once("Settings.php");
$TITLE = 'Tucson, AZ Weather';
$DESC  = "Tucson, AZ Weather Station: current weather, weather forecast, trends and history for Tucson, AZ";
$KEYW  = "Tucson, AZ Weather, weather, current weather, weather forecast";
############################################################################
# Find your NWS office here https://www.weather.gov/srh/nwsoffices It will be a 3 letter office like 'twc' for Tucson AZ (lowercase)
# also can be found here https://en.wikipedia.org/wiki/List_of_National_Weather_Service_Weather_forecast_offices
$myNWS = "twc";
###########################################################################
require_once("common.php");
include("cell-top.php");
###########################################################################

/* Get the Current legend */
$fileName = 'https://www.weather.gov/';
$fileName = $fileName.$myNWS.'/';


$the_source = get_data($fileName);
$startgrab = strpos($the_source, "<div id=\"wfomap_rtcol_bot\">");

$matches = array();
$match = preg_match ('/<\/div>.*\n.*<\/div>.*\n.*<\/div>.*\n.*<\/div>/',
                     $the_source, $matches, PREG_OFFSET_CAPTURE, $startgrab);
if ($match == 1)
{
  echo "<!-- preg_match returned match found -->\n";

  if (isset($matches[0][1]) )
  {
    echo "<!-- offset is " . $matches[0][1] . " -->\n";
    $finish = $matches[0][1];
  }
  else
    $finish = false;
}
else
{
  echo "<!-- preg_match returned match not found, start is $startgrab -->\n";
  $finish = false;

}

if ($finish !== false)
{
  $length = $finish-$startgrab;
  $the_legend = substr($the_source, $startgrab, $length);

  // change "&waa" in the URLs to use &amp;
  $the_legend = str_replace("&wwa", "&amp;wwa", $the_legend);

  $the_legend .= '</div></div></div></div>';	// Add back the terminal string we searched for in $finish
}
$startgrab2 = strpos ($the_legend,"There are no watches, warnings, or advisories at this time.");

if ($startgrab2 > 0) {
$the_legend = "There are no watches, warnings, or advisories at this time."; // no legend to print so put this text.
}
/* End Legend Acquisition */

?>
<div id="main-copy">
  
<?php // insert desired warning box at top of page

  if(isset($SITE['NWSalertsCodes']) and count($SITE['NWSalertsCodes']) > 0) {
    include_once("cell-nws-alerts-summary-inc.php");  
?> 
   

<?php } ?>	


<br />
<table width="100%">
	<tr>
		<td align="center"> <img src="https://forecast.weather.gov/wwamap/png/<?php echo$myNWS?>.png" width="<?php echo($pagewidth-12) ?>" alt="local advisories"/></td>
	</tr>
</table>
<br />


<table width="100%">
	<tr>
		<td align="center"> <strong>Weather Warning Legend</strong></td>
	</tr>
</table>



<div class="center" style="padding-left:22px">
<?php echo $the_legend;?> <!-- Display Current Legend -->
<!-- NOTE!  One or both of these two </div>'s that follow may not be needed, depending upon your server.
	If your page is improperly terminated, try removing one or both of these <div>'s. -->
</div>
</div>
<br />
<br />

<?php
############################################################################
include("cell-footer.php");
############################################################################
//------------------------------------------------------------------------------------------
function get_data($url)
{
  $ch = curl_init();
  $timeout = 5;
  curl_setopt($ch, CURLOPT_USERAGENT,'AlertsFetch/1.1 (Web Application, www.gwwilkins.org)');
  curl_setopt($ch,CURLOPT_URL,$url);
  curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
  curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // don't verify peer certificate
  $data = curl_exec($ch);
	if (curl_error($ch) <> '') { // IF there is an error
    print "<!-- curl Error: " . curl_error($ch) . " -->\n"; //  display error notice
  }
  curl_close($ch);
  return $data;
}
//------------------------------------------------------------------------------------------
?>