<?php
// cell-ajax-dashboard.php
//  Version 2.11 - 24-Jan-2012 - Based on ajax-dashboard 1.23
//  Version 2.2 - 9-Feb-2013 - Based on ajax-dashboard 1.26
//  Version 2.21 - 2-Apr-2013 added indoor temp
//  Version 2.34 - 28-Jun-2024 based on ajax-dashboard 1.34 
//  Added: heaven sundial from Alt-dashboard, changed the Fire icons, 
// got Ajax to work for gif's for wind direction and current condition
// note this requires changing ajaxWDws.js and updating the function ajax_wxIcon ( iconWD ) with the updated names and using those gifs

$ADBversion = 'cell-ajax-dashboard.php - Version 2.34 - 28-Jun-2024 - Multilingual';
//error_reporting(E_ALL);
// --- settings for standalone use --------------------------
$Lang    = 'en';
$uomTemp = '&deg;F';
$uomBaro = ' inHg';
$uomWind = ' mph';
$uomRain = ' in';
$uomSnow = ' in';
$uomPerHour = '/hr';
$uomDistance = ' miles';
$uomCloudHeight = ' ft';
$imagesDir = './ajax-images/';  // directory for ajax-images with trailing slash
$condIconDir = './ajax-images/'; // directory for condition icons
$condIconType = '.gif'; // default type='.jpg' -- use '.gif' for animated icons from http://www.meteotreviglio.com/
//  $timeFormat = 'D, d-M-Y g:ia T';  // Fri, 31-Mar-2006 6:35pm TZone
$timeFormat = 'd-M-Y g:ia';  // Fri, 31-Mar-2006 6:35pm TZone
$timeOnlyFormat = 'g:ia';    // h:mm[am|pm];
//$timeOnlyFormat = 'H:i';     // hh:mm
$dateOnlyFormat = 'd-M-Y';   // d-Mon-YYYY
$WDdateMDY = true;     // true=dates by WD are 'month/day/year'
//                     // false=dates by WD are 'day/month/year'

$ourTZ = "America/Phoenix";  //NOTE: this *MUST* be set correctly to
// translate UTC times to your LOCAL time for the displays.
//
// optional settings for the Wind Rose graphic in ajaxwindiconwr as wrName . winddir . wrType
$wrName   = 'wr-';       // first part of the graphic filename (followed by winddir to complete it)
$wrType   = '.gif';      // extension of the graphic filename
$wrHeight = '58';        // windrose graphic height=
$wrWidth  = '58';        // windrose graphic width=
$wrCalm   = 'wr-calm.gif';  // set to full name of graphic for calm display ('wr-calm.gif')
$haveUV   = true;        // set to false if no UV sensor
$haveSolar = true;       // set to false if no Solar sensor
$WXtags  =  'testtags.php';  // source of our weather variables
$fcstorg =   'NWS'; // default forecast organization ('NWS','EC','WU','WXSIM')
$fcstscript = 'advforecast2.php'; // default forecast script
//            NWS - 'advforecast2.php', EC - 'ec-forecast.php', 
//            WU - 'WU-forecast.php', WXSIM - 'plaintext-parser.php',
$UVscript		= 'get-UV-forecast-inc.php'; // worldwide forecast script for UV Index
//	comment out above line to exclude UV forecast
$DavisVP	= true; 	// set to false if weather station is not a Davis VP
$showSnow	= true;		// set to false if Snow values not recorded manually in WD
$showSnowTemp = 4;		// display Snow instead of Rain when temp (C) is <= this temperature.
$decimalComma = false;  // set to true to process numbers with a comma for a decimal point
$AQI           = true;
//$dayornight = 'Night'; for quick testing
$fire = true; //True = chandler, False = fire weather
$useNOAA = true; // use noaarec.php to get data for your location for max/min for the day (thanks to Beteljuice and Jerry Wilkins)
$indoor = true; //true = show indoor temp and humidity
$useSunlightPie = true;        // Use Sunlight Pie Chart from Steve Fitzgerald and Jerry Wilkins
$displayTomorrow = false; // show tomorrows daylight
$displayYesterday = false; // show yesterdays daylight
// --- end of settings for standalone use
//
if ($AQI) {include_once('get-aqi-rss-with-link.php');}   // get AQI index value for dashboard display

if (isset($_REQUEST['sce']) && ( strtolower($_REQUEST['sce']) == 'view' or
    strtolower($_REQUEST['sce']) == 'show') ) {
   //--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   
   readfile($filenameReal);
   exit;
}

if ($useNOAA) {
	include_once("noaarec.php");
	global $thisDayMax,$thisDayMaxYear,$thisDayMin,$thisDayMinYear,$thisDayMaxAvg,$thisDayMinAvg; // Access these values
}

include_once("common.php");  // for language translation
include_once("Settings.php"); 
// overrides from Settings.php if available
global $SITE,$forwardTrans,$reverseTrans;
$commaDecimal = false;
if (isset($SITE['lang'])) 	{$Lang = $SITE['lang'];}
if (isset($SITE['uomTemp'])) 	{$uomTemp = $SITE['uomTemp'];}
if (isset($SITE['uomBaro'])) 	{$uomBaro = $SITE['uomBaro'];}
if (isset($SITE['uomWind'])) 	{$uomWind = $SITE['uomWind'];}
if (isset($SITE['uomRain'])) 	{$uomRain = $SITE['uomRain'];}
if (isset($SITE['uomSnow'])) 	{$uomSnow = $SITE['uomSnow'];}
if (isset($SITE['uomPerHour'])) {$uomPerHour = $SITE['uomPerHour'];}
if (isset($SITE['imagesDir'])) 	{$imagesDir = $SITE['imagesDir'];}
if (isset($SITE['timeFormat'])) {$timeFormat = $SITE['timeFormat'];}
if (isset($SITE['timeOnlyFormat'])) {$timeOnlyFormat = $SITE['timeOnlyFormat'];}
if (isset($SITE['dateOnlyFormat'])) {$dateOnlyFormat = $SITE['dateOnlyFormat'];}
if (isset($SITE['WDdateMDY']))  {$WDdateMDY = $SITE['WDdateMDY'];}
if (isset($SITE['tz'])) 		{$ourTZ = $SITE['tz'];}
if (isset($SITE['UV'])) 		{$haveUV = $SITE['UV'];}
if (isset($SITE['SOLAR'])) 		{$haveSolar = $SITE['SOLAR'];}
if (isset($SITE['WXtags'])) 	{$WXtags = $SITE['WXtags'];}
if (isset($SITE['fcstorg']))	{$fcstorg = $SITE['fcstorg'];}
if (isset($SITE['fcstscript']))	{$fcstscript = $SITE['fcstscript'];}
if (isset($SITE['UVscript'])) 	{$UVscript = $SITE['UVscript'];}
if (isset($SITE['DavisVP'])) 	{$DavisVP = $SITE['DavisVP'];}
if (isset($SITE['showSnow'])) 	{$showSnow = $SITE['showSnow'];}
if (isset($SITE['commaDecimal'])) 	{$commaDecimal = $SITE['commaDecimal'];}
if (isset($SITE['fcsticonsdir'])) 	{$fcstIconDir = $SITE['fcsticonsdir'];}
if (isset($SITE['fcsticonstype'])) 	{$condIconType = $SITE['fcsticonstype'];}
$moonHemisphere = 'NH';
if ($SITE['latitude']<0)
   $moonHemisphere = 'SH';


// testing parameters// testing parameters
print "<!--  $ADBversion -->\n";

$DebugMode = false;
if (isset($_REQUEST['debug'])) {$DebugMode = strtolower($_REQUEST['debug']) == 'y'; }
if (isset($_REQUEST['UV'])) {$haveUV = $_REQUEST['UV'] <> '0';}
if (isset($_REQUEST['solar'])) {$haveSolar = $_REQUEST['solar'] <> '0';}
$displaySnow = false;  // assume normal rain display
if ($showSnow and strip_units($temperature) <= $showSnowTemp and 
  (isset($snowseasoncm) and isset($snowseasonin)) and
  ($snowseasoncm > 0.0 or $snowseasonin > 0.0) ) {
  $displaySnow = true;
}

if (isset($_REQUEST['snow'])) {$displaySnow = $_REQUEST['snow'] <> '0';}

$fcstby = isset($_REQUEST['fcstby'])?strtoupper($_REQUEST['fcstby']):'';
if ($fcstby == 'NWS') {
$SITE['fcstscript']		= 'advforecast2.php';  // USA-only NWS Forecast script
$SITE['fcstorg']		= 'NWS';    // set to 'NWS' for NOAA NWS
$fcstorg = $fcstby;
$fcstscript = $SITE['fcstscript'];
}

if ($fcstby == 'EC') {

$SITE['fcstscript']   = 'ec-forecast.php';    // Canada forecasts from Environment Canada
$SITE['fcstorg']		= 'EC';    // set to 'EC' for Environment Canada
$fcstorg = $fcstby;
$fcstscript = $SITE['fcstscript'];
}
if ($fcstby == 'WC') {

$SITE['fcstscript']	= 'WC-forecast.php';    // Non-USA, Non-Canada Wunderground/TWC Forecast Script
$SITE['fcstorg']		= 'WU/TWC';    // set to 'WU/TWC' for WeatherUnderground/TWC
$fcstorg = $fcstby;
$fcstscript = $SITE['fcstscript'];
}
if ($fcstby == 'AW') {

$SITE['fcstscript']	= 'AW-forecast.php';    // Non-USA, Non-Canada Aerisweather Forecast Script
$SITE['fcstorg']		= 'Aerisweather';    // set to 'Aerisweather' for Aerisweather.com
$fcstorg = $fcstby;
$fcstscript = $SITE['fcstscript'];
}

if ($fcstby == 'WXSIM') {

$SITE['fcstscript']	= 'plaintext-parser.php';    // WXSIM forecast
$SITE['fcstorg']		= 'WXSIM';    // set to 'WXSIM' for WXSIM forecast
$fcstorg = $fcstby;
$fcstscript = $SITE['fcstscript'];
}
if ($fcstby == 'PW') {

$SITE['fcstscript']	= 'PW-forecast.php';    // Pirateweather forecast
$SITE['fcstorg']		= 'PW';    // set to 'PW' for Pirateweather.net forecast
$fcstorg = $fcstby;
$fcstscript = $SITE['fcstscript'];
}
if ($fcstby == 'OWM') {

$SITE['fcstscript']	= 'OWM-forecast.php';    // OpenWeatherMap forecast
$SITE['fcstorg']		= 'OWM';    // set to 'OWM' for OpenWeatherMap.org forecast
$fcstorg = $fcstby;
$fcstscript = $SITE['fcstscript'];
}
if ($fcstby == 'VC') {

$SITE['fcstscript']	= 'VC-forecast.php';    // Pirateweather forecast
$SITE['fcstorg']		= 'VC';    // set to 'PW' for Pirateweather.net forecast
$fcstorg = $fcstby;
$fcstscript = $SITE['fcstscript'];
}
// end of special testing parms
print "<!-- fcstby='$fcstby' fcstscript='" . $SITE['fcstscript'] . "' fcstorg='". $SITE['fcstorg'] . "' -->\n"; 
// end of overrides from Settings.php

  include_once($WXtags);   // for the bulk of our data
  $doPrintNWS = false; // suppress printing of NWS forecast advforecast2.php
  $doPrint    = false; // suppress printing of EC  forecast EC-forecast.php
  $doPrintWU  = false; // suppress printing of old WU-forecast.php now defunct
  $doPrintWC  = false; // suppress printing of TWC/WU WC-forecast.php
	$doPrintPW  = false; // suppress printing of Pirateweather PW-forecast.php
	$doPrintAW  = false; // suppress printing of Aerisweather AW-forecast.php
	$doPrintOWM = false; // suppress printing of OpenWeatherMap OWM-forecast.php
	$doPrintVC  = false; // suppress printing of VisualCrossing VC-forecast.php
  include_once($fcstscript); // for the forecast icon stuff
  
// copy forecast script variables to carterlake-style names if script used is not advforecast2.php
if ($fcstorg == 'WU/TWC') {
  $forecasticons = $WCforecasticons;
  $forecasttemp = $WCforecasttemp;
  $forecasttitles = $WCforecasttitles;
  $forecasttext = $WCforecasttext;

} else if ($fcstorg == 'Aerisweather') {
  $forecasticons = $AWforecasticons;
  $forecasttemp = $AWforecasttemp;
  $forecasttitles = $AWforecasttitles;
  $forecasttext = $AWforecasttext;

} else if ($fcstorg == 'PW') {
  $forecasticons = $PWforecasticons;
  $forecasttemp = $PWforecasttemp;
  $forecasttitles = $PWforecasttitles;
  $forecasttext = $PWforecasttext;

} else if ($fcstorg == 'OWM') {
  $forecasticons = $OWMforecasticons;
  $forecasttemp = $OWMforecasttemp;
  $forecasttitles = $OWMforecasttitles;
  $forecasttext = $OWMforecasttext;

} else if ($fcstorg == 'VC') {
  $forecasticons = $VCforecasticons;
  $forecasttemp = $VCforecasttemp;
  $forecasttitles = $VCforecasttitles;
  $forecasttext = $VCforecasttext;

} else if ($fcstorg == 'EC') {
  foreach ($forecasticon as $i => $temp) {
  	$forecasticons[$i] = $forecasttitles[$i] . "<br />\n" .
	    $forecasticon[$i] . "\n" .
		  $forecasttext[$i] . "\n";
  }
  $forecasttext = $forecastdetail;
  foreach ($forecastdays as $i => $temp) {
     $t = explode('<br />',$forecastdays[$i]);
     $forecasttitles[$i] = $t[0];
  }


} else if ($fcstorg == 'WXSIM') {

	print "<!-- wxsim useCharSet='$useCharSet', ";
	print isset($useUTF8)?"useUTF8='$useUTF8'":"useUTF8 is not set";
	print " -->\n";
	if(isset($useUTF8) and $useUTF8 and $useCharSet !== 'UTF-8') { # convert WXSIM forecast to UTF-8
	  foreach ($WXSIMtext as $i => $tfcst) {
			$WXSIMicons[$i] = iconv($useCharSet,'UTF-8//TRANSLIT//IGNORE',$WXSIMicons[$i]);
			$WXSIMtemp[$i] = iconv($useCharSet,'UTF-8//TRANSLIT//IGNORE',$WXSIMtemp[$i]);
			$WXSIMtext[$i] = iconv($useCharSet,'UTF-8//TRANSLIT//IGNORE',$WXSIMtext[$i]);
			$WXSIMday[$i] = iconv($useCharSet,'UTF-8//TRANSLIT//IGNORE',$WXSIMday[$i]);
		}
	  print "<!-- WXSIMtext converted from '$useCharSet' to 'UTF-8' -->\n";
	}

  $forecasticons = $WXSIMicons;
  $forecasttemp  = $WXSIMtemp;
  $forecasttitles = $WXSIMday;
  $forecasttext = $WXSIMtext;

}
if (isset($SITE['WXSIM']) and $SITE['WXSIM'] == true and $fcstorg <> 'WXSIM') {
  $doPrint = false;
  include_once($SITE['WXSIMscript']);
	print "<!-- wxsim useCharSet='$useCharSet', ";
	print isset($useUTF8)?"useUTF8='$useUTF8'":"useUTF8 is not set";
	print " -->\n";
	if(isset($useUTF8) and $useUTF8 and $useCharSet !== 'UTF-8') { # convert WXSIM forecast to UTF-8
	  foreach ($WXSIMtext as $i => $tfcst) {
			$WXSIMtext[$i] = iconv($useCharSet,'UTF-8//TRANSLIT//IGNORE',$tfcst);
		}
	  print "<!-- WXSIMtext converted from '$useCharSet' to 'UTF-8' -->\n";
	}
}
print "<!-- Lang='$Lang' -->\n";
if ($Lang <> 'en') { // try changing windrose graphics test for the Calm graphic
  $tfile = preg_replace('|^'.$wrName.'|',$wrName.$Lang.'-',$wrCalm);
  print "<!-- checking for '" . $imagesDir.$tfile . "' -->\n";
  if (file_exists($imagesDir.$tfile)) {
    print "<!-- alternate windrose for '" . $Lang . "' loaded -->\n";
	print '<script type="text/javascript">';
	print "\n var wrCalm = \"$tfile\";\n";
	print " var wrName = \"$wrName$Lang-\";\n";
	if(!isset($SITE['langTransloaded'])) {
		if(count($forwardTrans)>0) {
		   print "// Language translation for conditions by ajaxWDwx.js\n";
		}
		foreach ($forwardTrans as $key => $val) {
		   print "  langTransLookup['$key'] = '$val';\n";
		}
		$SITE['langTransloaded'] = true;
	}
	print "</script>\n";
	$wrCalm = $tfile;  // change the PHP dashboard settings too
	$wrName = $wrName . $Lang . '-';
	print "<!-- new wrName='$wrName', wrCalm='$wrCalm' -->\n";
  } 
}

// --- end of settings -------------------

if($SITE['WXsoftware'] == 'WD') {
// Sample from WD: $moonage = "Moon age: 10 days,10 hours,41 minutes,80%";	// current age of the moon (days since new moon)
// Sample from WD: $moonphase = "80%";	// Moon phase %
  $moonagedays = preg_replace('|^Moon age:\s+(\d+)\s.*$|is',"\$1",$moonage);
  if($moonphase == '') { // MAC version of WD is missing this value
    preg_match_all('|(\d+)|is',$moonage,$matches);
    $moonphase  = $matches[1][3];
	if(isset($matches[1][4])) {
	  $moonphase .= '.' . $matches[1][4]; // pick up decimal;
	  $moonphase = round($moonphase,0);
	}
	$moonphase .= '%';
  }
} else { // perform non-WD moon stuff
	$mooninfo = cGetMoonInfo();  /* Note:  getMoonInfo() is located in common.php */
/* returns $mooninfo of:
    [age] => 9 days, 11 hours, 57 minutes
    [ill] => 65
    [pic] => 8
    [phase] => Waxing Gibbous
    [NM] => 1294131882
    [NMGMT] => Tue, 04-Jan-2011 09:04 GMT
    [NMWD] => 09:04 GMT 04 January 2011
    [Q1] => 1294831983
    [Q1GMT] => Wed, 12-Jan-2011 11:33 GMT
    [Q1WD] => 11:33 GMT 12 January 2011
    [FM] => 1295472210
    [FMGMT] => Wed, 19-Jan-2011 21:23 GMT
    [FMWD] => 21:23 GMT 19 January 2011
    [Q3] => 1298590089
    [Q3GMT] => Thu, 24-Feb-2011 23:28 GMT
    [Q3WD] => 23:28 GMT 24 February 2011
    [Q4] => 1296700310
    [Q4GMT] => Thu, 03-Feb-2011 02:31 GMT
    [Q4WD] => 02:31 GMT 03 February 2011
    [FM2] => 1298018189
    [FM2GMT] => Fri, 18-Feb-2011 08:36 GMT
    [FM2WD] => 08:36 GMT 18 February 2011
*/
	print "<!-- cGetMoonInfo returns\n".print_r($mooninfo,true)." -->\n";
	if(!isset($moonphase)) {$moonphase = $mooninfo->ill.'%'; }
	if(!isset($newmoon))   {$newmoon   = $mooninfo->NMWD;    }
	if(!isset($nextnewmoon)) {$nextnewmoon = $mooninfo->Q4WD; } /*check this! */
	if(!isset($firstquarter)) {$firstquarter = $mooninfo->Q1WD; }
	if(!isset($lastquarter)) {$lastquarter = $mooninfo->Q3WD; }
	if(!isset($fullmoon))    {$fullmoon = $mooninfo->FMWD; }
	if(!isset($moonphasename)) {$moonphasename = $mooninfo->phase;}
	if(!isset($moonagedays))  {$moonagedays = $mooninfo->pic; }
	if(!isset($moonage))      {$moonage = 'Moon age: '.$mooninfo->age.','.$mooninfo->ill.'%'; }
    if(file_exists("get-USNO-sunmoon.php")) { 
      include_once("get-USNO-sunmoon.php");
	  $USNOdata = getUSNOsunmoon();
   }
   if(isset($USNOdata['sunrise']))                 {$sunrise =     $USNOdata['sunrise']; }  
   if(isset($USNOdata['sunrisedate']))             {$sunrisedate = $USNOdata['sunrisedate']; }  
   if(isset($USNOdata['sunset']))                  {$sunset =      $USNOdata['sunset']; }  
   if(isset($USNOdata['sunsetdate']))              {$sunsetdate =  $USNOdata['sunsetdate']; }  
   if(isset($USNOdata['moonrise']))                {$moonrise =    $USNOdata['moonrise']; }  
   if(isset($USNOdata['moonrisedate']))            {$moonrisedate= $USNOdata['moonrisedate']; }  
   if(isset($USNOdata['moonset']))                 {$moonset =     $USNOdata['moonset']; }  
   if(isset($USNOdata['moonsetdate']))             {$moonsetdate = $USNOdata['moonsetdate']; }  
   if(isset($USNOdata['moonphase']))               {$moonphasename = $USNOdata['moonphase']; }  
   if(isset($USNOdata['illumination']))            {$moonphase = $USNOdata['illumination']; }  
   if(isset($USNOdata['hoursofpossibledaylight'])) {$hoursofpossibledaylight = $USNOdata['hoursofpossibledaylight'];} 
}
# Set timezone in PHP5/PHP4 manner
  if (!function_exists('date_default_timezone_set')) {
	putenv("TZ=" . $ourTZ);
#	$Status .= "<!-- using putenv(\"TZ=$ourTZ\") -->\n";
    } else {
	date_default_timezone_set("$ourTZ");
#	$Status .= "<!-- using date_default_timezone_set(\"$ourTZ\") -->\n";
   }
  $UpdateDate = date($timeFormat,strtotime("$date_year-$date_month-$date_day  $time_hour:$time_minute:00"));
//  $UpdateDate = "$date_year-$date_month-$date_day  $time_hour:$time_minute:00";
$monthname = langtransstr($monthname);
$dayname = langtransstr(substr($dayname,0,3));
//
// Snow setup
if (preg_match('|in|i',$uomSnow) and isset($snowseasonin)) { // use USA measurements
  $snowseason = $snowseasonin;	// Snow for season you have entered under input daily weather, inches
  $snowmonth = $snowmonthin;	// Snow for month you have entered under input daily weather, inches
  $snowtoday = $snowtodayin;	// Snow for today you have entered under input daily weather, inches
  $snowyesterday = $snowyesterday;	// Yesterdays' snow
  $snownow = $snownowin;	// Current snow depth, inches.
} elseif (isset($snowseasoncm)) { // use Metric measurements
  $snowseason = $snowseasoncm;	// Snow for season you have entered under input daily weather, cm
  $snowmonth = $snowmonthcm;	// Snow for month you have entered under input daily weather, cm
  $snowtoday = $snowtodaycm;	// Snow for today you have entered under input daily weather, cm
  $snowyesterday = $snowyesterday;	// Yesterdays' snow
  $snownow = $snownowcm;	// Current snow depth, cm.
}
$decimalComma = (strpos($temperature,',') !==false)?true:false; // using comma for decimal point?
// end of functions
// -----------------------------------------------------------------------------
// CHANGE IN DAYLENGTH FUNCTION:  computes length of yesterday, today,  & tomorrow
//   and then the change in day length from yesterday to today
// Written by SE Lincoln Weather                                                           .
// -----------------------------------------------------------------------------
// Alternate $changeinday routine that finds $changeinday2
if (!function_exists('get_changeinday')) { // Avoid fatally re-declaring this!!!
	function get_changeinday() {
		global $displayTomorrow,$displayYesterday;
		$hrsOfSunLight = array();
		global $SITE;
	
		$t = time()-86400; // Yesterday
	
		for ($i=0; $i<(2+($displayTomorrow?1:0)); $i++) { // Only loop twice if no $displayTomorrow
			$sun = date_sun_info($t, $SITE['latitude' ], $SITE["longitude"]);
			$srise  = $sun["sunrise"];
			$sset  = $sun["sunset"];
			$sunhrs[$i] = $sset - $srise;   // $sunhrs is time between sunrise and sunset
			$sh[$i] = floor($sunhrs[$i]/3600); // Sun Hours
			$sm[$i] = floor((($sunhrs[$i]/3600)-$sh[$i])*60); // Sun Minutes
			$ss[$i] = round(((((($sunhrs[$i]/3600)-$sh[$i])*60)-$sm[$i])*60),0); // Sun Seconds
			$hrsOfSunLight[$i] = $sh[$i].':'.$sm[$i].':'.$ss[$i]; // Assemble strings in array
			$t+=86400; // Next Day
		}
	
		$cindsign = (($sunhrs[1]-$sunhrs[0])>0)?'+':'-'; // Change IN Day sign
	
		$shdiff = ($cindsign=='-'?($sh[0] - $sh[1]):($sh[1] - $sh[0])); // Difference in hours
		$smdiff = ($cindsign=='-'?($sm[0] - $sm[1]):($sm[1] - $sm[0])); // Difference in minutes
		$ssdiff = ($cindsign=='-'?($ss[0] - $ss[1]):($ss[1] - $ss[0])); // Difference in seconds
		if ($ssdiff<0) { // negative number of seconds?
			$smdiff -= 1; // borrow
			$ssdiff += 60; // and carry
		}
		if ($smdiff<0) { // negative number of minutes?
			$shdiff -=1; // borrow
			$smdiff += 60; // and carry
		}
		$changeinday2 = $cindsign.$shdiff.':'.$smdiff.':'.$ssdiff; // Assemble cind string
		$result = array($changeinday2,$hrsOfSunLight);
		return $result;
	}
}
// end of get_changeinday()

$moon = cgetMoonInfo();
if($SITE['latitude' ] >= 0)
     $HF = 'NH'; // use Northern Hemisphere moon img
else $HF = 'SH'; // use Southern Hemisphere moon img

// --- end of initialization code ---------
?>

<!-- start of cell-ajax-dashboard.php -->
<div class="ajaxDashboard">
<div style="border: 1px solid #ccc;">
<div id="update" style="clear:both">
	<table width="100%">
        <tr align="center">
          <td class="data1" style="text-align: center">
		    <span class="ajax" id="ajaxindicator"><?php langtrans('Updated'); ?>:</span>&nbsp;@ 
		    <span class="ajax" id="ajaxdate">
		    <?php echo fixup_date($date) . ' ' . fixup_time($time);
			  if(isset($timeofnextupdate)) { echo " - " . langtransstr('next update at') . " " . fixup_time($timeofnextupdate);} ?>
		    </span>&nbsp;<span class="ajax" id="ajaxtime"></span>
            <?php if(isset($SITE['ajaxScript'])) { ?>
            <?php langtrans('updated'); ?> 
			<script type="text/javascript"><!--
				document.write(' (<span id="ajaxcounter">0</span>&nbsp;<?php langtrans('sec ago'); ?>)');
            --></script>
            <?php } // there is a ajaxScript ?>
          </td>
        </tr>
	</table>		
</div>
<div id="summary" style="clear: both">
   <div class="datahead"><?php  langtrans('Summary'); ?></div>
   <table width="100%">
      <tr align="center">
         <td align="center" style="padding:2px; text-align: center;border: none; padding-left:0px;">
            <span class="ajax" id="ajaxthermometer">
               <?php $tstr = langtransstr("Currently") . ": $temperature, "
                           . langtransstr('Max') . ": $maxtemp, ".langtransstr('Min').": $mintemp"; ?>
               <img src="thermometer.php?t=<?php echo $temperature; ?>" alt="<?php echo $tstr; ?>" title="<?php echo $tstr; ?>" height="170" width="54" />
            </span>
         </td>
         <td style="text-align: center; border: none" valign="middle">
            <div><span class="ajax" id="ajaxconditionicon">
				<img src="<?php echo $condIconDir . newIcon($iconnumber) ?>" alt="<?php $t1 = fixupCondition($Currentsolardescription); echo $t1; ?>" 
				title="<?php echo $t1; ?>" height="58" width="55" />
            </span></div>
            <div><span class="ajax" id="ajaxcurrentcond"><?php echo $t1; ?></span></div>
            <?php if ($currentrainratehr>0) { // It's raining ?>
            <div><span class="ajax" id="ajaxrainratehr"><?php echo langtransstr($rainmsg).' ('.strip_units($currentrainratehr) . trim($uomRain).$uomPerHour; ?>)</span></div>
            <?php } ?>
            <span class="ajax" id="ajaxtemp" style="font-size:24px">
            <?php echo strip_units($temperature) . $uomTemp; ?>
			</span>
            <br/> <?php  langtrans('Temp Trend'); ?>
				  <span class="ajax" id="ajaxtemparrow"><?php 
				     if(isset($tempchangehour)) {
						 if($commaDecimal) {
							$Tnow = preg_replace('|,|','.',strip_units($temperature));
							$TLast = preg_replace('|,|','.',strip_units($tempchangehour)); 
						 } else {
							$Tnow = strip_units($temperature);
							$TLast = strip_units($tempchangehour); 
						 }
					 echo gen_difference($Tnow, $Tnow - $TLast, '',
			         langtransstr('Warmer').' %s'.$uomTemp.' '. langtransstr('than last hour') .'.',
			         langtransstr('Colder').' %s'.$uomTemp.' '. langtransstr('than last hour') .'.');
					 } // isset tempchangehour ?></span>
            <br/>
            <span class="ajax" id="ajaxheatcolorword"><b><?php  echo $heatcolourword; ?></b></span>
            <br/>
			<?php if(isset($feelslike)) { ?>
			<?php langtrans('Feels like'); ?>: <span class="ajax" id="ajaxfeelslike">
				<?php echo $feelslike . $uomTemp; ?> </span>
			<?php } // $feelslike ?>
            <br/>
			<?php if(isset($temp24hoursago)) { ?>
			<?php langtrans('24-hr difference'); ?>
			<br />
			<?php 
				if($commaDecimal) {
					$Tnow = preg_replace('|,|','.',strip_units($temperature));
					$TLast = preg_replace('|,|','.',strip_units($temp24hoursago)); 
				} else {
					$Tnow = strip_units($temperature);
					$TLast = strip_units($temp24hoursago); 
				}
			echo gen_difference($Tnow, $TLast, $uomTemp,
				langtransstr('Warmer'). ' %s'.$uomTemp.' '.langtransstr('than yesterday at this time').'.',
				langtransstr('Colder'). ' %s'.$uomTemp.' '.langtransstr('than yesterday at this time').'.'); ?>
			<?php } // $temp24hoursago ?>
         </td>
      </tr>
    </table>
	<table width="100%" style="margin-top: 3px; font-size: 10px; border-collapse:collapse; ">
      <tr>
		<th style="padding:1px;width:30%" align="left">&nbsp;</th>
		<th style="border:1px solid black;padding:1px;text-align: center; width:35%"><?php langtrans('Today'); ?></th>
        <th style="border:1px solid black;padding:1px;text-align: center; width:35%"><?php langtrans('Yesterday'); ?></th>
      </tr>
      <tr>
		<td style="border:1px solid black;padding:1px;text-align: center;">&nbsp;<strong><span style="color:red; font-weight:bold">High</span></strong></td>
        <td style="border:1px solid black;padding:1px;text-align: center;">
			<span class="ajax" id="ajaxtempmax"><b><?php echo strip_units($maxtemp) . $uomTemp; ?></b></span>
            @ <?php echo fixup_time($maxtempt); ?>
		</td>
        <td style="border:1px solid black;padding:1px;text-align: center;">
            <b><?php echo strip_units($maxtempyest) . $uomTemp; ?></b>
			@ <?php echo fixup_time($maxtempyestt); ?>
		</td>
      </tr>
      <tr>
		<td style="border:1px solid black;padding:1px;text-align: center;">&nbsp;<strong><span style=";color:blue; font-weight:bold">Low</span></strong></td>
        <td style="border:1px solid black;padding:1px;text-align: center;">
			<span class="ajax" id="ajaxtempmin"><b><?php echo strip_units($mintemp) . $uomTemp; ?></b></span> 
            @ <?php echo fixup_time($mintempt); ?>
		</td>
		<td style="border:1px solid black;padding:1px;text-align: center;">
			<b><?php echo strip_units($mintempyest) . $uomTemp; ?></b> 
			@ <?php echo fixup_time($mintempyestt); ?>
		</td>
      </tr>            
	</table>
<?php if ($useNOAA) { ?>
<div class="datahead2"><?php  langtrans('Averages / Records'); ?></div>
	<table width="100%" style="font-size: 10px; border-color: black; border-collapse:collapse; ">
		<tr>
			<th colspan="2" style="border:1px solid black;padding:1px;text-align: center;"><?php  langtrans('Average Temperatures'); ?><br /><?php  langtrans('This Date'); ?></th>
			<th colspan="2" style="border:1px solid black;padding:1px;text-align: center;"><?php  langtrans('Record Temperatures'); ?><br /><?php  langtrans('This Date'); ?></th>
		</tr>
		<tr>
			<td style="border:1px solid black;padding:1px;text-align: center;width:25%"><span style="color:red; font-weight:bold"><?php langtrans('Average High'); ?></span><br /><?php echo strip_units($thisDayMaxAvg) . $uomTemp; ?></td>
			<td style="border:1px solid black;padding:1px;text-align: center;width:25%"><span style="color:blue; font-weight:bold"><?php langtrans('Average Low'); ?></span><br /><?php echo strip_units($thisDayMinAvg) . $uomTemp; ?></td>
			<td style="border:1px solid black;padding:1px;text-align: center;width:25%"><span style="color:red; font-weight:bold"><?php langtrans('Record High'); ?></span><br /><?php echo strip_units($thisDayMax) . $uomTemp; ?>&nbsp;(<?php echo $thisDayMaxYear; ?>)</td>
			<td style="border:1px solid black;padding:1px;text-align: center;width:25%"><span style="color:blue; font-weight:bold"><?php langtrans('Record Low'); ?></span><br /><?php echo strip_units($thisDayMin) . $uomTemp; ?>&nbsp;(<?php echo $thisDayMinYear; ?>)</td>
		</tr>
	</table>
</div>
<?php } else { ?>
<div class="datahead2"><?php  langtrans('Records'); ?></div>
	<table width="100%" style="font-size: 10px; border-color: black; border-collapse:collapse; ">
		<tr>
			<th colspan="2" style="border:1px solid black;padding:1px;text-align: center;"><?php  langtrans('Record Temperatures This Date'); ?></th>
		</tr>
		<tr>
			<td style="border:1px solid black;padding:1px;text-align: center;width:25%"><span style="color:red; font-weight:bold"><?php langtrans('Record High'); ?></span><br /><?php  echo strip_units($maxtemp4today) . $uomTemp; ?> - <?php  echo $maxtemp4todayyr; ?></td>
			<td style="border:1px solid black;padding:1px;text-align: center;width:25%"><span style="color:blue; font-weight:bold"><?php langtrans('Record Low'); ?></span><br /><?php  echo strip_units($mintemp4today) . $uomTemp; ?> - <?php  echo $mintemp4todayyr; ?></td>
		</tr>
	</table>
</div>
<?php } ?>
<div id="Wind-Rose" style="clear: both">
   <table width="100%" style="border-collapse:collapse;">
	  <tr>
		<?php if ($AQI) { ?>
			<td class="datahead2" colspan="2" ><?php langtrans('Wind'); ?></td>
			<td class="datahead2"><?php langtrans('Air Quality'); ?></td>
		<?php } else { ?>
			<td class="datahead2" colspan="3"><?php langtrans('Wind'); ?></td>
		<?php } ?>
		</tr>
	  <tr>
        <td valign="middle" align="center" style="padding: 4px;">
			<span class="ajax" id="ajaxwindiconwr">
				<?php $wr = $imagesDir . $wrName . $dirlabel . $wrType; // normal wind rose
					$wrtext = langtransstr('Wind from') ." " . langtransstr($dirlabel);
					if ( (strip_units($avgspd) + strip_units($gstspd) < 0.1 ) and
						($wrCalm <> '') ) { // use calm instead
						$wr = $imagesDir . $wrCalm;
						$wrtext = $bftspeedtext;
					}?>
				    <img src="<?php echo $wr; ?>" 
					height="<?php echo $wrHeight; ?>" width="<?php echo $wrWidth; ?>" 
					title="<?php echo $wrtext; ?>" 
					alt="<?php echo $wrtext; ?>"  style="text-align:center" />
			</span> 
		</td>
		<td valign="middle" class="data1" style="text-align: center; border: none;" >
			<span class="ajax" id="ajaxwinddir"><?php langtrans($dirlabel); ?></span><br/> 
			<span class="ajax" id="ajaxwind">
				<?php echo strip_units($avgspd); ?>
				</span><br/>
				<span class="meas"><?php langtrans('Gust'); ?>:<br/></span> 
				<span class="ajax" id="ajaxgust">
					<?php echo strip_units($gstspd). " $uomWind"; ?>
				</span> 
        </td>
		<?php if ($AQI) { ?>
		<td rowspan="2" align="center" valign="middle" style="padding-left: 2px; border-left: 1px solid silver; border-bottom: 1px solid silver;"><?php echo $dashbrdAQI; ?> <br />
			<?php if($showGI) { getGraphic1($realIndex1, $aqiLevels, $aqiGraphic, $imagesDir); }?>
		</td>
		<?php } ?>
      </tr>
      <tr>
        <td colspan="2" class="Field" align="center" style="border-bottom: 1px solid silver;">
			<i><span class="ajax" id="ajaxbeaufortnum"><?php echo strip_units($beaufortnum); ?></span> Bft - 
			<span class="ajax" id="ajaxbeaufort"><?php langtrans($bftspeedtext); ?></span></i>
        </td>
      </tr>
      <tr>
		<?php if ($AQI) { ?>
        <td class="Field" colspan="2"><?php langtrans('Max Gust');?>
		<?php } else { ?>
        <td class="Field" colspan="1"><?php langtrans('Max Gust');?>
		<?php } ?>
			<?php langtrans('Today at '); ?><span class="ajax" id="ajaxwindmaxgusttime"><?php echo fixup_time($maxgstt); ?></span>
        </td>
        <td style="text-align: right;">
            <span class="ajax" id="ajaxwindmaxgust"><?php echo $mrecordwindgust . $uomWind; ?></span>
        </td>
      </tr>
      <tr>
		<?php if ($AQI) { ?>
        <td class="Field" colspan="2"><?php langtrans('Max');?>
		<?php } else { ?>
        <td class="Field" colspan="1"><?php langtrans('Max');?>
		<?php } ?>
            <?php langtrans('Gust This month on'); ?>
            <?php echo langtransstr($monthname)." ".$mrecordhighgustday; ?>
        </td>
        <td style="text-align: right;">
            <span class="convWind"><?php echo $mrecordwindgust . $uomWind; ?></span>
        </td>
      </tr>
   </table>
</div>

<div id="HumidityBaro" style="clear: both;text-align:left;">
   <div class="datahead"><?php langtrans('Dewpoint, Humidity'); ?> &amp; <?php langtrans('Barometer'); ?></div>
   <table width="100%">
      <tr>
        <td class="Field"><?php langtrans('Humidity'); ?>:</td>
        <td style="text-align: right;">
            <span class="ajax" id="ajaxhumidity"><?php echo $humidity; ?></span>%
                  <?php
				   if(isset($humchangelasthour)) {
					 $t1 = preg_replace('|\s|s','',$humchangelasthour);
					 if($commaDecimal) {
						$Tnow = preg_replace('|,|','.',strip_units($humidity));
						$TLast = preg_replace('|,|','.',strip_units($t1)); 
					 } else {
						$Tnow = strip_units($humidity);
						$TLast = strip_units($t1); 
					 }
					 
					 echo gen_difference($Tnow, $Tnow-$TLast, '',
					 langtransstr('Increased').' %s%% '.langtransstr('since last hour').'.',
					 langtransstr('Decreased').' %s%% '.langtransstr('since last hour').'.');
				   } ?>
        </td>
      </tr>
      <tr>
        <td class="Field"><?php langtrans('Dew Point'); ?>: </td>
        <td style="text-align: right;">
            <span class="ajax" id="ajaxdew">
				<?php $t1 = strip_units($dewpt); echo $t1 . $uomTemp;  ?>
            </span>
                  <?php 
				  if(isset($dewchangelasthour)) {
					if($commaDecimal) {
						$Tnow = preg_replace('|,|','.',strip_units($dewpt));
						$TLast = preg_replace('|,|','.',strip_units($dewchangelasthour)); 
					 } else {
						$Tnow = strip_units($dewpt);
						$TLast = strip_units($dewchangelasthour); 
					 }
					 echo gen_difference($Tnow, $Tnow-$TLast, '',
					 langtransstr('Increased').' %s'.$uomTemp.' '.langtransstr('since last hour').'.',
					 langtransstr('Decreased').' %s'.$uomTemp.' '.langtransstr('since last hour').'.'); 
				  } ?>
        </td>
      </tr>
      <tr>
        <td class="Field"><?php langtrans('Barometer'); ?>:</td>
        <td style="text-align: right;">
            <span class="ajax" id="ajaxbaro">
                <?php $t1 = strip_units($baro); echo $t1 . $uomBaro; ?>
            </span>
            <span class="ajax" id="ajaxbaroarrow">
                  <?php 
				  if(isset($trend)) {
					if($commaDecimal) {
						$Tnow = preg_replace('|,|','.',strip_units($baro));
						$TLast = preg_replace('|,|','.',strip_units($trend)); 
					 } else {
						$Tnow = strip_units($baro);
						$TLast = strip_units($trend); 
					 }
					 $decPts = 1;
					 if(preg_match('|in|i',$uomBaro)) {$decPts = 2; }
					 echo gen_difference($Tnow, $Tnow-$TLast, '',
					 langtransstr('Rising') . ' %s '.$uomBaro.$uomPerHour,
					 langtransstr('Falling') . ' %s '.$uomBaro.$uomPerHour, $decPts); 
				  } ?>
            </span>
        </td>
      </tr>
      <tr>
        <td class="Field"><?php langtrans('Baro Trend'); ?>: </td>
        <td style="text-align: right;">
            <span class="ajax" id="ajaxbarotrendtext">
                <?php  echo langtrans($pressuretrendname); ?>
            </span>
        </td>
      </tr>
		<?php if ($indoor) { ?>
	  <tr>
		<td class="Field" style="white-space: nowrap;"><?php langtrans('Indoor Temp'); ?>: </td>
        <td style="text-align: right;">
			<span class="ajax" id="ajaxindoortemp">
                <?php $t1 = strip_units($indoortemp); echo $t1 . $uomTemp;  ?>
			</span>
        </td>
      </tr>
	  <tr>
        <td class="Field" style="white-space: nowrap;"><?php langtrans('Indoor Humidity'); ?>:</td>
        <td style="text-align: right;">
			<span class="ajax" id="ajaxindoorhumid">
				<?php echo $indoorhumid;?>
			</span>%
		</td>
      </tr>
		<?php } ?>	  
   </table>
</div>

<div id="RainSnow" style="clear: both;text-align:left;">
   <div class="datahead">Rainfall</div>
   <table width="100%" style="border-collapse:collapse;">
      <tr>
        <td class="Field"><?php langtrans('Rain Today:') ?></td>
        <td style="text-align: right;">
			<span class="ajax" id="ajaxrain">
				<?php echo strip_units($dayrn) . $uomRain; ?>
			</span>
        </td>
      </tr>
      <tr>
        <td class="Field"><?php langtrans('Rain Yesterday:') ?> </td>
        <td style="text-align: right;">
			<span class="ajax" id="ajaxrainydy">
				<?php echo strip_units($yesterdayrain) . $uomRain; ?>
			</span>
        </td>
      </tr>
      <tr>
        <td class="Field"><?php langtrans('Storm Rain:'); ?> </td>
        <td style="text-align: right;">
            <?php echo strip_units($vpstormrain).$uomRain; ?>
        </td>
      </tr>
      <tr>
        <td class="Field" style="border-top: 1px solid silver;"><?php echo langtransstr(date("F")).' '.langtransstr('Total'); ?>:</td>
        <td style="text-align: right; border-top: 1px solid silver;">
			<span class="ajax" id="ajaxrainmo">
				<?php echo strip_units($monthrn) . $uomRain; ?>
			</span>
		</td>
      </tr>
      <tr>
        <td class="Field"><?php langtrans('Season Total'); ?>:</td>
        <td style="text-align: right;">
			<span class="ajax" id="ajaxrainyr">
				<?php echo strip_units($yearrn) . $uomRain; ?>
			</span>
        </td>
      </tr>
      <?php if($snownowcm > 0) { // show depth of snow if needed ?>
      <tr>
        <td class="Field"><?php langtrans('Snow Depth'); ?>:</td>
        <td style="text-align: right;">
            <?php echo strip_units($snownow) . $uomSnow; ?>
        </td>
      </tr>
      <?php } // end show-depth-of-snow if needed ?>      
   </table>
</div>
<div id="Forecast" style="clear: both; text-align:left">
	<div class="datahead"><?php  langtrans('Short Term Forecast'); ?></div>
	<table width="100%">
	  <tr>
		<td style="width: 80px;font-size: 8pt; border:none; text-align: center" valign="middle" align="center"><strong><?php echo $forecasticons[0]; ?> </strong><br /><?php echo $forecasttemp[0]; ?></td>
		<td style="width: 80px;font-size: 8pt; border:none; text-align: center" valign="middle" align="center"><strong><?php echo $forecasticons[1]; ?> </strong><br /><?php echo $forecasttemp[1]; ?></td>
		<td style="width: 80px;font-size: 8pt; border:none; text-align: center" valign="middle" align="center"><strong><?php echo $forecasticons[2]; ?> </strong><br /><?php echo $forecasttemp[2]; ?></td>
	  </tr>
	</table>
</div>

<?php
// construct 4 flavors of the UV/ Solar display based on status of $haveUV and $haveSolar
// $haveUV && $haveSolar :  UV on left, Solar on Right
// $haveUV && !$haveSolar:  UV on left, UV Forecast on right
// !$haveUV && $haveSolar:  UV forecast on left, Solar on right
// !$haveUV && !$haveSolar: UV Forecast on left, UV Forecast+1 on right

$leftHead = langtransstr('UV Index');
if (!$haveUV) { $leftHead = langtransstr('UV Index Forecast'); }

$rightHead = langtransstr('Solar Radiation');
if (!$haveSolar) {$rightHead = langtransstr('UV Index Forecast'); }

$UVfcstDate = array_fill(0,9,'');   // initialize the return arrays
$UVfcstUVI  = array_fill(0,9,'n/a');

if (isset($UVscript)) { // load up the UV forecast script
  @include_once($UVscript);
}
$UVptr = 0;  // index for which day to use
//$VPuv = 6.1;

#UV Index, Solar radiation, FWI
?>

<div id="UVSolarFire" style="clear: both">
	<table width="100%" style="border-collapse:collapse">
	  <tr>
        <td colspan="3" class="datahead2" style="text-align:center"><?php echo $leftHead; ?></td>
        <td colspan="3" class="datahead2" style="text-align:center"><?php echo $rightHead; ?></td>
        <td class="datahead2" style="text-align:center"><?php langtrans('Fire Risk'); ?></td>
	  </tr>
	  <tr>
			<?php if (($haveUV) && ($dayornight == 'Day')) {  //  Have a UV sensor .. show realtime data & not night ?>			
                <td align="center" style="white-space: nowrap; text-align: center; font-size: 9px;border-left: 1px solid black; border-bottom: 1px solid black;">
					<span class="ajax" id="ajaxuv" style="font-size: 14px;"><?php echo $VPuv; ?></span><br /><?php langtrans('Sunburn in'); ?><br />
					<span class="ajax" id="ajaxuvburnrate"><?php echo $burntime; ?></span> <?php langtrans('Minutes'); ?>
                </td>
				<td style="border-bottom: 1px solid black;" align="center">
					<?php $VPuv2 = ''; // clear var ?>
					<?php
					$VPuv2 = round($VPuv);
					if ($VPuv2 >= 11) { $VPuv2 = 11;
					} ?>
					<span class="ajax" id="ajaxuvimg">
						<img src="ajax-images/UV<?php echo $VPuv2; ?>.gif" height="65" width="34" alt="" title="Current UV rate" />
					</span>
				</td>
				<td align ="center" style="white-space: nowrap; text-align:center; font-size: 9px; border-bottom: 1px solid black;">
					<?php langtrans('Highest'); ?>:<br />
					<?php echo $highuvtime; ?><br />
					<span style="font-size: 14px;"><?php echo $highuv; ?></span>
				</td>
			<?php } else {  //  don't have UV sensor .. show UV forecast instead ?>
		<?php if ((($dayornight == 'Night') && ($haveUV)) || (($dayornight == 'Night') && (!$haveUV)) || (($dayornight == 'Day') && (!$haveUV))){ ?>
		<?php
			   		$evening=0; 			// Need to adjust forecasts if it's before Midnight after dark
			   		if ($time_hour>12) {  	// because the forecasts points at wrong day otherwise
				   		$evening=1;			// and forecast isn't for 'tomorrow'.
						$UVptr++; // increment counter 
						}
                ?>
		<td align="center" style="white-space:nowrap; text-align: center; font-size: 9px;border-left: 1px solid black;<?php if(!$haveUV) {?> border-bottom: 1px solid black<?php } ?>">
			<?php
			$VPuv2 = round($UVfcstUVI[$UVptr-$evening],0);
			if ($VPuv2 >= 11) { $VPuv2 = 11;
			} ?>
			<?php $UVshortdate = mktime(0,0,0,date("m"), date("d")+$UVptr, date("y")); ?>
			<?php echo date("M-d",$UVshortdate) ?><br/>
			<img src="ajax-images/UV<?php echo $VPuv2; ?>.gif" height="45" width="34" alt="" title="Predicted UV rate" /><br/>
			<b><a href="<?php echo htmlspecialchars($UV_URL); ?>" title="<?php echo strip_tags($requiredNote); ?>"><?php echo $UVfcstUVI[$UVptr-$evening]; ?></a></b>
			<?php $UVptr++; // increment counter ?>
			<?php $VPuv2 = ''; // clear var ?>
		</td>
		<td align="center" style="white-space:nowrap; text-align: center; font-size: 9px;<?php if(!$haveUV) {?> border-bottom: 1px solid black<?php } ?>">
			<?php
			$VPuv2 = round($UVfcstUVI[$UVptr-$evening],0);
			if ($VPuv2 >= 11) { $VPuv2 = 11;
			} ?>
			<?php $UVshortdate = mktime(0,0,0,date("m"), date("d")+$UVptr, date("y")); ?>
			<?php echo date("M-d",$UVshortdate) ?><br/>
			<img src="ajax-images/UV<?php echo $VPuv2; ?>.gif" height="45" width="34" alt="" title="Predicted UV rate" /><br/>
			<b><a href="<?php echo htmlspecialchars($UV_URL); ?>" title="<?php echo strip_tags($requiredNote); ?>"><?php echo $UVfcstUVI[$UVptr-$evening]; ?></a></b>
			<?php $UVptr++; // increment counter ?>
			<?php $VPuv2 = ''; // clear var ?>
		</td>
		<td align="center" style="white-space:nowrap; text-align: center; font-size: 9px;<?php if(!$haveUV) {?> border-bottom: 1px solid black<?php } ?>">
			<?php
			$VPuv2 = round($UVfcstUVI[$UVptr-$evening],0);
			if ($VPuv2 >= 11) { $VPuv2 = 11;
			} ?>
			<?php $UVshortdate = mktime(0,0,0,date("m"), date("d")+$UVptr, date("y")); ?>
			<?php echo date("M-d",$UVshortdate) ?><br/>
			<img src="ajax-images/UV<?php echo $VPuv2; ?>.gif" height="45" width="34" alt="" title="Predicted UV rate" /><br/>
			<b><a href="<?php echo htmlspecialchars($UV_URL); ?>" title="<?php echo strip_tags($requiredNote); ?>"><?php echo $UVfcstUVI[$UVptr-$evening]; ?></a></b>
			<?php $UVptr++; // increment counter ?>
			<?php $VPuv2 = ''; // clear var ?>
		</td>  
		  <?php } ?>			
			<?php } // end $haveUV  ---------------------------------------- ?>
				<?php if ($haveSolar) {  // Have a Solar Sensor  show current values ?>
				  <?php if ($dayornight == 'Night'){ ?>
					<td colspan="3" <?php if ($haveUV) { ?> rowspan="2" <?php } ?> style="white-space:nowrap; text-align: center; font-size:12px;border: 1px solid black;">
						<?php if ($time_hour > 12) { // Display Summary if in the evening ?>
							<?php langtrans('High Today'); ?>:&nbsp; <?php echo $highsolar; ?><br />
								&nbsp;@&nbsp;<?php echo $highsolartime; ?><br />
						<?php } else { ?>
							<?php langtrans('High Yest'); ?>:&nbsp;&nbsp; <?php echo $highsolaryest; ?><br />
								&nbsp;@&nbsp;<?php echo $highsolaryesttime; ?><br />
						<?php } ?>
						<?php langtrans('Today'); ?>:&nbsp;<?php echo $sunshinehourstodateday; ?><?php  langtrans('Hrs'); ?> <br />
						<?php langtrans('Month'); ?>:&nbsp;<?php echo $sunshinehourstodatemonth; ?> <?php  langtrans('Hrs'); ?>
					</td>
				  <?php } ?>
				  <?php if ($dayornight == 'Day') { ?>
			   <td align="center" class="data2" style="white-space:nowrap; text-align: center; font-size: 9px; border-left: 1px solid black; border-bottom: 1px solid black;">
				<span class="ajax" id="toggleSI">
				   <script type="text/javascript">
					function toggle_SI(){
					 	if (document.getElementById("ajaxSIWm2").style.display == 'none') {
					   		document.getElementById("ajaxSIWm2").style.display = 'inline'
					   		document.getElementById("ajaxSIimgWm2").style.display = 'inline'
					   		document.getElementById("ajaxSISolarp").style.display = 'none'
					   		document.getElementById("ajaxSIimgSolarp").style.display = 'none'
					 	} else {
 					  		document.getElementById("ajaxSIWm2").style.display = 'none'
					   		document.getElementById("ajaxSIimgWm2").style.display = 'none'
					   		document.getElementById("ajaxSISolarp").style.display = 'inline'
					   		document.getElementById("ajaxSIimgSolarp").style.display = 'inline'
					 	}
					};
				   </script>
               </span> 
                  <span class="ajax" id="ajaxsolar" style="font-size: 14px;"><?php echo $VPsolar; ?></span> W/m<span style="vertical-align:super">2</span><br/>
                  <span class="ajax" id="ajaxsolarpct"><?php echo strip_units($currentsolarpercent); ?>
                   </span>%<br/>
                  <span class="ajax" id="ajaxSIWm2" style="display:inline; font-size: 8px;" onclick="javascript:toggle_SI()">W/m<span style="vertical-align:super">2</span> <b>&rArr;</b> SI</span>
                  <span class="ajax" id="ajaxSISolarp" style="display:none; font-size: 8px;" onclick="javascript:toggle_SI()">Solar % <b>&rArr;</b> SI</span>
               </td>
			   <td align="center" style="border-bottom: 1px solid black;">
                  <span class="ajax" id="ajaxSIimgWm2" style="display:inline"
                 	 onclick="javascript:toggle_SI()">
                 	 <img src="ajax-images/SI<?php echo round(($VPsolar*10)/(round($recordhighsolar,0)),0);?>.gif" height="65" width="34"
                        alt="" id="ajaxsiimg" title="Current WM2 Solar Index"/></span>
                  <span class="ajax" id="ajaxSIimgSolarp" style="display:none" 
                 	 onclick="javascript:toggle_SI()">
                     <img src="ajax-images/SI<?php echo floor(strip_units($currentsolarpercent)*0.1);?>.gif" height="65" width="34"
                        alt="" id ="ajaxsiimg2" title="Current Solar% Solar Index"/></span>
               </td>
			   <td align="center" style="white-space:nowrap; text-align:center; font-size: 9px;border-bottom: 1px solid black;">
						<?php langtrans('Highest'); ?>:<br />
						<?php echo $highsolartime; ?><br />
						<span style="font-size: 14px;"><?php echo $highsolar; ?></span>
					</td>
				  <?php } ?>
				<?php } else { // don't have solar  show info instead ?>
					<td colspan="3" <?php if ($haveUV) { ?> rowspan="2" <?php } ?> style="text-align: center; white-space:nowrap;border-left: 1px solid black; border-bottom: 1px solid black;" >
						<?php langtrans('Sunrise is at'); ?>: <?php echo $sunrise; ?><br />
						<?php langtrans('Solar Noon'); ?>: <?php echo $solarnoon; ?><br />
						<?php langtrans('Sunset is at'); ?>: <?php echo $sunset; ?><br />
					</td>
				<?php } // end $haveSolar  ?>
		<td align="center" style="border: 1px solid black;" <?php if (($haveUV) && ($dayornight == 'Night')) { ?> rowspan="2" <?php } ?> >
			<?php if ($fire) {
				switch ($chandler) {
					case ($chandler <= 0):
						echo "<img src=\"${imagesDir}CBI-Fire0.png\" alt=\"Chandler Burning Index: LOW\" width=\"70px\" height=\"70px\" /> <br />";
					break;
					case (($chandler >= 0) and ($chandler < 50)):
						echo "<img src=\"${imagesDir}CBI-Fire0.png\" alt=\"Chandler Burning Index: LOW\" width=\"70px\" height=\"70px\" /> <br />";
					break;
					case (($chandler >= 50) and ($chandler < 75)):
						echo "<img src=\"${imagesDir}CBI-Fire16.png\" alt=\"Chandler Burning Index: MODERATE\" width=\"70px\" height=\"70px\" /> <br />";
					break;
					case (($chandler >= 75) and ($chandler < 90)):
						echo "<img src=\"${imagesDir}CBI-Fire25.png\" alt=\"Chandler Burning Index: HIGH\" width=\"70px\" height=\"70px\" /> <br />";
					break;
					case (($chandler >= 90) and ($chandler <= 97.5)):
						echo "<img src=\"${imagesDir}CBI-Fire31.png\" alt=\"Chandler Burning Index: VERY HIGH\" width=\"70px\" height=\"70px\" /> <br />";
					break;
					case (($chandler > 97.5) ):
						echo "<img src=\"${imagesDir}CBI-Fire32.png\" alt=\"Chandler Burning Index: EXTREME\" width=\"70px\" height=\"70px\" /> <br />";
					break;
				} // end switch
					langtrans('Currently'); ?>:<br/>
					<b><?php  echo $chandler; ?></b><br/>
					<?php echo " at " . $time; ?>
					<br/>
			<?php
			} else {
				switch ($firewi) {
					case ($firewi == 0):
						echo "<img src=\"${imagesDir}CBI-Fire0.png\" alt=\"Fire Weather Index: LOW\" width=\"70px\" height=\"70px\" /> <br />";
					break;
					case (($firewi >= 0) and ($firewi <= 7)):
						echo "<img src=\"${imagesDir}CBI-Fire0.png\" alt=\"Fire Weather Index: LOW\" width=\"70px\" height=\"70px\" /> <br />";
					break;
					case (($firewi >= 7.1) and ($firewi < 16)):
						echo "<img src=\"${imagesDir}CBI-Fire16.png\" alt=\"Fire Weather Index: MODERATE\" width=\"70px\" height=\"70px\" /> <br />";
					break;
					case (($firewi >= 16) and ($firewi < 25)):
						echo "<img src=\"${imagesDir}CBI-Fire25.png\" alt=\"Fire Weather Index: HIGH\" width=\"70px\" height=\"70px\" /> <br />";
					break;
					case (($firewi >= 25) and ($firewi <= 31)):
						echo "<img src=\"${imagesDir}CBI-Fire31.png\" alt=\"Fire Weather Index: VERY HIGH\" width=\"70px\" height=\"70px\" /> <br />";
					break;
					case (($firewi > 31) ):
						echo "<img src=\"${imagesDir}CBI-Fire32.png\" alt=\"Fire Weather Index: EXTREME\" width=\"70px\" height=\"70px\" /> <br />";
					break;
				} // end switch
					langtrans('Today'); ?>:<br/>
					<?php  echo $firewi; ?> of 31
                <br/>	
			<?php } ?>
		</td>
      </tr>
	<?php if (($haveUV) && ($dayornight == 'Night')) { ?>
	  <tr>
				<td align="center" colspan="3" style="white-space:nowrap; text-align: center; font-size: 10px; border-right: 1px solid black; border-left: 1px solid black; border-bottom: 1px solid black">
						<?php if ($time_hour > 12) { // Display Summary if in the evening ?>
							<?php langtrans('High Today'); ?>:&nbsp;&nbsp;<span style="font-size: 9px;">
							<?php echo $highuv; ?>&nbsp;@&nbsp;<?php echo $highuvtime; ?></span>
						<?php } else { ?>
							<?php langtrans('High Yest'); ?>:&nbsp;&nbsp;<span style="font-size: 9px;">
							<?php echo $highuvyest; ?>&nbsp;@&nbsp;<?php echo $highuvyesttime; ?></span>
						<?php  } ?>
				</td>
	  </tr>
	<?php  } ?>

	</table>
</div>

<div id="Almanac" style="clear: both">
	<table width="100%" style="border-collapse:collapse">
	  <tr>
        <td class="datahead2" style="width:50%; text-align:center"><?php langtrans('Almanac'); ?></td>
        <td class="datahead2" style="width:25%; text-align:center"><?php langtrans('Sun'); ?></td>
        <td class="datahead2" style="width:25%; text-align:center"><?php langtrans('Moon'); ?></td>
	  </tr>
	  <tr>	
		<td valign="middle" style="padding-left: 2px;">
			<div class="ForecastDetails Sun">
				<span class="Field"><?php langtrans('Sunrise'); ?>:</span>&nbsp;<span class="ajax Value" id="ajaxsunrise"><?php echo fixup_time($sunrise); ?></span>
				<div style="height: 4px;"></div>
				<span class="Field"><?php langtrans('Sunset' ); ?>:</span>&nbsp;<span class="ajax Value" id="ajaxsunset"><?php echo fixup_time($sunset); ?></span>
			</div>
			<div class="ForecastDetails Moon">
				<?php
				$msTime = strtotime($moonset);
				$mrTime = strtotime($moonrise);
				if ($msTime<$mrTime) {
				?>
                <span class="Field"><?php langtrans('Moonset' ); ?>:</span>&nbsp;<span class="ajax Value" id="ajaxmoonset"><?php echo fixup_time($moonset); ?></span>
				<div style="height: 4px;"></div>
                <span class="Field"><?php langtrans('Moonrise'); ?>:</span>&nbsp;<span class="ajax Value" id="ajaxmoonrise"><?php echo fixup_time($moonrise); ?></span>
				<?php } else { ?>
				<span class="Field"><?php langtrans('Moonrise'); ?>:</span>&nbsp;<span class="ajax Value" id="ajaxmoonrise"><?php echo fixup_time($moonrise); ?></span>
				<div style="height: 4px;"></div>
                <span class="Field"><?php langtrans('Moonset' ); ?>:</span>&nbsp;<span class="ajax Value" id="ajaxmoonset"><?php echo fixup_time($moonset); ?></span>
				<?php } ?>
			</div>
		</td>

				<td style="text-align: center; border: none;border-left: 1px solid black;"> <?php langtrans('Sunlight'); ?>: <br/>
					<?php
					if(file_exists("heavens.php")) {
						include_once("heavens.php");
							}
						$hrsOfSunLight = array(); // [0] = yesterday, [1] = today, [2] = tomorrow
						$theChanges = get_changeinday(); // Also Populates $hrsOfSunLight array
						$changeinday2 = $theChanges[0];
						$hrsOfSunLight = $theChanges[1];
						$time_arr = explode(':', $changeinday2);
						if ($time_arr[1] < 8) { //Check for bogus minute differences on Standard Time <=> Sunlight Time Change Days
						if ($useSunlightPie)  { //Make piechart if not using IE or if IE's Pie Chart is OK
					?> 
					<span class="data2" style="font-size: 8px;"><?php
						$time_arr = explode(':', $changeinday2);
						$time_arr[0]>0?$cidsign = '+': $cidsign ='-';
						if ($time_arr[1]< 5) {
						if ($displayYesterday) {
							$time_arr2 = explode(':', $hrsOfSunLight[0]);
							echo ' '.langtransstr('Yest.:') . (int)$time_arr2[0] . " h " . (int)$time_arr2[1] . " m " . (int)$time_arr2[2]." s" . '<br/>';
//							echo '<br/>'.langtransstr('of Sunlight Yesterday').'<br/>';
						}
						$time_arr = explode(':', $hrsOfSunLight[1]);
						if ($displayTomorrow || $displayYesterday) {
						echo ' '.langtransstr('Today:') . (int)$time_arr[0] . " h " . (int)$time_arr[1] . " m " . (int)$time_arr[2]." s" . '<br/>';
						} else {
						echo ' '.langtransstr('Today:') . (int)$time_arr[0] . " h " . (int)$time_arr[1] . " m " . (int)$time_arr[2]." s" . '<br/>';
						}
//						echo '<span style="font-size:8px;line-height:130%"><br/>'.langtransstr('of Sunlight Today').'</span>';
						}
					?>
					</span>
					<span class="data2" style="font-size: 8px;"><?php
//						echo langtransstr('Which is').' ';
//						$time_arr = explode(':', $changeinday2);
//						echo ((int)$time_arr[1]>0?'<br/>'.(int)$time_arr[1] . " m ":' ') . $time_arr[2];
//						echo (substr($time_arr[0],0,1) != "-")?' '.langtransstr('sec long.'):' '.langtransstr('sec short.');
//						echo ' '.langtransstr('than yest.').'<br/>'; // '-' when getting shorter
						if ($displayTomorrow) {
							$time_arr3 = explode(':', $hrsOfSunLight[2]);
							echo ' '.langtransstr('Tom:') . (int)$time_arr3[0] . " h " . (int)$time_arr3[1] . " m " . (int)$time_arr3[2]." s" . '<br/>';
//							echo '<br/>'.langtransstr('of Sunlight Tomorrow').'<br/>';
							} else {
							}
					?>
					</span>
					<span class="data2" style="font-size: 10px; text-align: center;">	(<?php langtrans('Noon');?>)<br/>
					 <img src="cache/heavenpie.png?<?php echo rand()?>" alt="graph" width="50px" height="50px" id="HeavenPie"/><br/>
					(<?php langtrans('Midnight');?>)
					<br/>
					</span>
						<?php } ?>
						<?php } ?>
				</td>
		
		<td style="text-align: center; border: none;border-left: 1px solid black;">
			<?php langtrans(moonphase($moonage)); ?> <br /><img src="<?php echo $imagesDir .'moon/w/' . $moonHemisphere .'-moon'. str_pad($moonagedays, 2, "0", STR_PAD_LEFT) ?>.gif"
			 alt="<?php $t1 =  moonphase($moonage) . ", Moon at $moonagedays days in cycle"; echo $t1; ?>" title="<?php echo $t1; ?>" width="48" height="48" style="border: 0;" />
			 <br />
			<?php  echo $moonphase ?>
			 <br />
			<?php langtrans('Illuminated'); ?>
		</td>
	  </tr>
	</table>
</div>

<div id="MoonPhases" style="clear: both">
	<div class="datahead"><?php langtrans('Moon Phases'); ?></div>
	<table width="100%" style="background: black; color: white; font: 12px Arial;">
	  <tr>
		<td align="center" valign="bottom" style="width:25%; padding-top:7px;"><b><?php echo langtransstr($moon->moons[0][0]) ;?></b></td>
		<td align="center" valign="bottom" style="width:25%; padding-top:7px;"><b><?php echo langtransstr($moon->moons[1][0]); ?></b></td>
		<td align="center" valign="bottom" style="width:25%; padding-top:7px;"><b><?php echo langtransstr($moon->moons[2][0]); ?></b></td>
		<td align="center" valign="bottom" style="width:25%; padding-top:7px;"><b><?php echo langtransstr($moon->moons[3][0]); ?></b></td>
	  </tr>
	  <tr>
		<td align="center">
			<img src="<?php echo $SITE['imagesDir'].'m-'.$HF.'-'.$moon->moons[0][2].'.gif'; ?>" width="40" height="40" 
				alt  ="<?php echo langtransstr($moon->moons[0][0]); ?>" title="<?php echo langtransstr($moon->moons[0][0]); ?>"/>
		</td>
		<td align="center">
			<img src="<?php echo $SITE['imagesDir'].'m-'.$HF.'-'.$moon->moons[1][2].'.gif'; ?>" width="40" height="40" 
				alt  ="<?php echo langtransstr($moon->moons[1][0]); ?>" title="<?php echo langtransstr($moon->moons[1][0]); ?>"/>
		</td>
		<td align="center">
			<img src="<?php echo $SITE['imagesDir'].'m-'.$HF.'-'.$moon->moons[2][2].'.gif'; ?>" width="40" height="40"
			alt  ="<?php echo langtransstr($moon->moons[2][0]); ?>"	title="<?php echo langtransstr($moon->moons[2][0]); ?>"/>
		</td>
		<td align="center">
			<img src="<?php echo $SITE['imagesDir'].'m-'.$HF.'-'.$moon->moons[3][2].'.gif'; ?>" width="40" height="40"
			alt  ="<?php echo langtransstr($moon->moons[3][0]); ?>" title="<?php echo langtransstr($moon->moons[3][0]); ?>"/>
		</td>
	 </tr>
	  <tr>
		<td align="center">
			<?php echo   date("d M Y H:i",$moon->moons[0][1]); ?>
		</td>
		<td align="center">
			<?php echo   date("d M Y H:i",$moon->moons[1][1]); ?>
		</td>
		<td align="center">
			<?php echo   date("d M Y H:i",$moon->moons[2][1]); ?>
		</td>
		<td align="center">
			<?php echo   date("d M Y H:i",$moon->moons[3][1]); ?>
		</td>
	  </tr>
	</table>
</div>

</div>

</div>
<!-- end of ajax-dashboard.php -->
<?php

//=========================================================================
//
// Functions
//
//=========================================================================
//  generate an up/down arrow to show differences

function gen_difference( $nowTemp, $yesterTemp, $Legend, $textUP, $textDN, $DP=1) {
// version 1.01 - handle ',' as decimal point on input
  global $imagesDir,$commaDecimal,$DebugMode;
  if($commaDecimal) {
    $tnowTemp = preg_replace('|,|','.',strip_units($nowTemp));
    $tyesterTemp = preg_replace('|,|','.',strip_units($yesterTemp));
  } else {
	$tnowTemp = strip_units($nowTemp);
	$tyesterTemp = strip_units($yesterTemp);
  }
  $diff = round(($tnowTemp - $tyesterTemp),3);
  $absDiff = abs($diff);
  $diffStr = sprintf("%01.".$DP."F",$diff);
  $absDiffStr = sprintf("%01.".$DP."F",$absDiff);
  if($commaDecimal) {
	 $absDiffStr = preg_replace('|\.|',',',$absDiffStr);
  }
  if($DebugMode) {
	  echo "<!-- gen_difference DP=$DP now='$nowTemp':'$tnowTemp' yest='$yesterTemp':'$tyesterTemp' dif='$diff':'$diffStr' absDiff='$absDiff':'$absDiffStr' -->\n";
	  echo "<!-- txtUP='$textUP' txtDN='$textDN' Legend='$Legend' -->\n";
  }
  if ($diffStr == '0.0') {
 // no change

$image = '&nbsp;'; 
  
  } elseif ($diffStr > '0.0') {
// today is greater 
$msg = sprintf($textUP,$absDiffStr); 
$image = "<img src=\"{$imagesDir}rising.gif\" alt=\"$msg\" title=\"$msg\" width=\"7\" height=\"8\" style=\"border: 0; margin: 1px 3px;\" />";

  
  } else {
// today is lesser
$msg = sprintf($textDN,$absDiffStr); 
$image = "<img src=\"{$imagesDir}falling.gif\" alt=\"$msg\" title=\"$msg\" width=\"7\" height=\"8\" style=\"border: 0; margin: 1px 3px;\" />";
   
  }
   if ($Legend) {
       return ($diff . $Legend . $image);
	} else {
	   return $image;
	}
}

//=========================================================================
//  decode UV to word+color for display

function get_UVrange ( $inUV ) {
// figure out a text value and color for UV exposure text
//  0 to 2  Low
//  3 to 5 	Moderate
//  6 to 7 	High
//  8 to 10 Very High
//  11+ 	Extreme
   if(strpos($inUV,',') !== false ) {
	   $uv = preg_replace('|,|','.',$inUV);
   } else {
	   $uv = $inUV;
   }
   switch (TRUE) {
     case ($uv == 0):
       $uv = langtransstr('None');
     break;
     case (($uv > 0) and ($uv < 3)):
       $uv = '<span style="border: solid 1px; color: black; background-color: #A4CE6a;">&nbsp;' . langtransstr('Low') . '&nbsp;</span>';
     break;
     case (($uv >= 3) and ($uv < 6)):
       $uv = '<span style="border: solid 1px; color: black; background-color: #FBEE09;">&nbsp;' . langtransstr('Medium') . '&nbsp;</span>';
     break;
     case (($uv >=6 ) and ($uv < 8)):
       $uv = '<span style="border: solid 1px; color: black; background-color: #FD9125;">&nbsp;' . langtransstr('High') . '&nbsp;</span>';
     break;
     case (($uv >=8 ) and ($uv < 11)):
       $uv = '<span style="border: solid 1px; color: #FFFFFF; background-color: #F63F37;">&nbsp;' . langtransstr('Very&nbsp;High') . '&nbsp;</span>';
     break;
     case (($uv >= 11) ):
       $uv = '<span style="border: solid 1px; color: #FFFF00; background-color: #807780;">&nbsp;' . langtransstr('Extreme') . '&nbsp;</span>';
     break;
   } // end switch
   return $uv;
} // end get_UVrange

//=========================================================================
// change the hh:mm AM/PM to h:mmam/pm format
function fixup_time ( $WDtime ) {
  global $timeOnlyFormat,$DebugMode;
  if ($WDtime == "00:00: AM") { return ''; }
  $t = explode(':',$WDtime);
  if (preg_match('/p/i',$WDtime)) { $t[0] = $t[0] + 12; }
  if ($t[0] > 23) {$t[0] = 12; }
  if (preg_match('/^12.*a/i',$WDtime)) { $t[0] = 0; }
  $t2 = join(':',$t); // put time back to gether;
  $t2 = preg_replace('/[^\d\:]/is','',$t2); // strip out the am/pm if any
  $r = date($timeOnlyFormat , strtotime($t2));
  if ($DebugMode) {
    $r = "<!-- fixup_time WDtime='$WDtime' t2='$t2' -->" . $r;
    $r = '<span style="color: green;">' . $r . '</span>'; 
  }
  return ($r);
}

//=========================================================================
// adjust WD date to desired format
//
function fixup_date ($WDdate) {
  global $timeFormat,$timeOnlyFormat,$dateOnlyFormat,$WDdateMDY,$DebugMode;
  $d = explode('/',$WDdate);      // expect ##/##/## form
  if(!isset($d[2])) {$d = explode('-',$WDdate); } // try ##-##-#### form instead
  if(!isset($d[2])) {$d = explode('.',$WDdate); } // try ##.##.#### form instead
  if ($d[2] > 70 and $d[2] <= 99) {$d[2] += 1900;} // 2 digit dates 70-99 are 1970-1999
  if ($d[2] < 99) {$d[2] += 2000; } // 2 digit dates (left) are assumed 20xx dates.
  if ($WDdateMDY) {
    $new = sprintf('%04d-%02d-%02d',$d[2],$d[0],$d[1]); //  M/D/YYYY -> YYYY-MM-DD
  } else {
    $new = sprintf('%04d-%02d-%02d',$d[2],$d[1],$d[0]); // D/M/YYYY -> YYYY-MM-DD
  }
  
  $r = date($dateOnlyFormat,strtotime($new));
  if ($DebugMode) {
    $r = "<!-- fixup_date WDdate='$WDdate', WDdateUSA='$WDdateMDY' new='$new' -->" . $r;
    $r = '<span style="color: green;">' . $r . '</span>'; 
  }
  return ($r);
}

//=========================================================================
// strip trailing units from a measurement
// i.e. '30.01 in. Hg' becomes '30.01'
function strip_units ($data) {
  preg_match('/([\d\,\.\+\-]+)/',$data,$t);
  return (float) $t[1]; // Wim suggestion 26-Jul-2018
}

//=========================================================================
// decode WD %moonage% tag and return a text description for the moon phase name
// "Moon age: 10 days,10 hours,41 minutes,80%"

function moonphase ($WDmoonage) {

  preg_match_all('|(\d+)|is',$WDmoonage,$matches);
//  print "<!-- matches=\n" . print_r($matches,true) . "-->\n";
  $mdays = $matches[1][0];
  $mhours = $matches[1][1];
  $mmins = $matches[1][2];
  $mpct  = $matches[1][3];
  
  $mdaysd = $mdays + ($mhours / 24) + ($mmins / 1440);
  // Definitions from http://www.answers.com/topic/lunar-phase
  //  * Dark Moon - Not visible
  //  * New Moon - Not visible, or traditionally, the first visible crescent of the Moon
  //  * Waxing Crescent Moon - Right 1-49% visible
  //  * First Quarter Moon - Right 50% visible
  //  * Waxing gibbous Moon - Right 51-99% visible
  //  * Full Moon - Fully visible
  //  * Waning gibbous Moon - Left 51-99% visible
  //  * Third Quarter Moon - Left 50% visible
  //  * Waning Crescent Moon - Left 1-49% visible
  //  * New Moon - Not visible

  if ($mdaysd <= 29.53/2) { // increasing illumination
    $ph = "Waxing";
	$qtr = "First";
  } else { // decreasing illumination
    $ph = "Waning";
	$qtr = "Last";
  }
  
  if ($mpct < 1 ) { return("New Moon"); }
  if ($mpct <= 49) { return("$ph Crescent"); }
  if ($mpct < 51) { return("$qtr Quarter"); }
  if ($mpct < 99) { return("$ph Gibbous"); }
	return("Full Moon");
 }


//=========================================================================
// pick the NOAA style condition icon based on iconnumber 
function newIcon($numb) {
  global $condIconDir,$condIconType;
  
  $iconList = array(
	"skc.jpg",          //  0 imagesunny.visible
	"nskc.jpg",         //  1 imageclearnight.visible
	"bkn.jpg",          //  2 imagecloudy.visible
	"sct.jpg",          //  3 imagecloudy2.visible
	"nbkn.jpg",         //  4 imagecloudynight.visible
	"sct.jpg",          //  5 imagedry.visible
	"fg.jpg",           //  6 imagefog.visible
	"hazy.jpg",         //  7 imagehaze.visible
	"ra.jpg",           //  8 imageheavyrain.visible
	"few.jpg",          //  9 imagemainlyfine.visible
	"mist.jpg",         // 10 imagemist.visible
	"nfg.jpg",          // 11 imagenightfog.visible
	"nra.jpg",          // 12 imagenightheavyrain.visible
	"novc.jpg",         // 13 imagenightovercast.visible
	"nra.jpg",          // 14 imagenightrain.visible
	"nshra.jpg",        // 15 imagenightshowers.visible
	"nsn.jpg",          // 16 imagenightsnow.visible
	"ntsra.jpg",        // 17 imagenightthunder.visible
	"ovc.jpg",          // 18 imageovercast.visible
	"sct.jpg",          // 19 imagepartlycloudy.visible
	"ra.jpg",           // 20 imagerain.visible
	"ra.jpg",           // 21 imagerain2.visible
	"shra.jpg",         // 22 imageshowers2.visible
	"ip.jpg",           // 23 imagesleet.visible
	"ip.jpg",           // 24 imagesleetshowers.visible
	"sn.jpg",           // 25 imagesnow.visible
	"sn.jpg",           // 26 imagesnowmelt.visible
	"sn.jpg",           // 27 imagesnowshowers2.visible
	"skc.jpg",          // 28 imagesunny.visible
	"scttsra.jpg",      // 29 imagethundershowers.visible
	"hi_tsra.jpg",      // 30 imagethundershowers2.visible
	"tsra.jpg",         // 31 imagethunderstorms.visible
	"nsvrtsra.jpg",     // 32 imagetornado.visible
	"wind.jpg",         // 33 imagewindy.visible
	"ra1.jpg",          // 34 stopped rainning
	"windyrain.jpg"     // 35 windy/rain 
	);	
	$tempicon = $iconList[$numb];
	if($condIconType <> '.jpg') {
	  $tempicon = preg_replace('|\.jpg|',$condIconType,$tempicon);
	}
	return($tempicon);
}

// Function to process %Currentsolarcondition% string and 
// remove duplicate stuff, then fix capitalization, and translate from English if needed
//  
  function fixupCondition( $inCond ) {
    global $DebugMode;
	
    $Cond = str_replace('_',' ',$inCond);
	$Cond = strtolower($Cond);
	$Cond = preg_replace('| -|','',$Cond);
	$Cond = trim($Cond);
	$dt = '';
	
	$vals = array();
	if(strpos($Cond,'/') !==false) {
		$dt .= "<!-- vals split on slash -->\n";
		$vals = explode("/",$Cond);
	}
	if(strpos($Cond,',') !==false) {
		$dt .= "<!-- vals split on comma -->\n";
		$vals = explode(",",$Cond);
	}
	$ocnt = count($vals);
	if($ocnt < 1) { return(langtransstr(trim($inCond))); }
	foreach ($vals as $k => $v) { 
	  if($DebugMode) { $dt .= "<!-- v='$v' -->\n"; }
	  $v = ucfirst(strtolower(trim($v)));
	  $vals[$k] = langtransstr($v); 
	  if($DebugMode) { $dt .= "<!-- vals[$k]='".$vals[$k]."' -->\n"; }
	}
	
	if($vals[0] == '') {$junk = array_shift($vals);}
	if(isset($vals[2]) and $vals[0] == $vals[2]) {$junk = array_pop($vals);}
	reset($vals);
	$t = join(', ',$vals);
	
//	return($Cond . "' orig=$ocnt n=" . count($vals) ." t='$t'");
    if($DebugMode) {
      $t = "<!-- fixupCondition in='$inCond' out='$t' ocnt='$ocnt' -->" . $dt . $t;
	}
    return($t);
  
  }
function get_SIrange ( $solarpercent ) {
   switch (TRUE) {
     case ($solarpercent == 0):
       $si = '0';
     break;
     case (($solarpercent > 0) and ($solarpercent < 10)):
       $si = '0';
     break;
     case (($solarpercent >= 10) and ($solarpercent < 20)):
       $si = '1';
     break;
     case (($solarpercent >= 20) and ($solarpercent < 30)):
       $si = '2';
     break;
     case (($solarpercent >= 30) and ($solarpercent < 40)):
       $si = '3';
     break;
     case (($solarpercent >= 40) and ($solarpercent < 50)):
       $si = '4';
     break;
     case (($solarpercent >= 50) and ($solarpercent < 60)):
       $si = '5';
     break;
     case (($solarpercent >= 60) and ($solarpercent < 70)):
       $si = '6';
     break;
     case (($solarpercent >= 70) and ($solarpercent < 80)):
       $si = '7';
     break;
     case (($solarpercent >= 80) and ($solarpercent < 90)):
       $si = '8';
     break;
     case (($solarpercent >= 90) and ($solarpercent < 100)):
       $si = '9';
     break;
     case ($solarpercent >= 100):
       $si = '10';
     break;
   } // end switch
   return $si;
} // end get_Solarrange

function get_localdate ( $indate) {
  global $SITE;
  $EnglishMonths = array(
   'January','February','March','April','May','June',
   'July','August','September','October','November','December');
   
// Change '02:33 UTC 4 September 2007' to
//        specified date by  
  $timeFormat = 'D, d-M-Y h:ia T';  // Fri, 31-Mar-2006 14:03 TZone
//  $timeFormat = 'h:ia T D, d-M-Y ';  // Fri, 31-Mar-2006 14:03 TZone
  if(isset($SITE['timeFormat'])) { $timeFormat = $SITE['timeFormat']; }
  
  $utcstr = substr($indate,10) . " " . substr($indate,0,9); // move formats
  echo "<!-- input utcstr='$utcstr' -->\n";

 // input dates are assumed to be in English only
 if (isset($SITE['monthNames'])) {
    // convert TO English for strtotime()
    echo "<!-- before utcstr='$utcstr' -->\n";
	foreach ($EnglishMonths as $i => $monthEN) {
	   $utcstr = preg_replace('|'.$SITE['monthNames'][$i].'|i',$monthEN,$utcstr);
	}  
    echo "<!-- after utcstr='$utcstr' -->\n";
  }

  $utc = strtotime($utcstr);
  $lclstr = date($timeFormat,$utc);
  if (isset($SITE['langMonths'])) {
    // convert From English for return (will only work if long-format month names in $timeFormat)  
    echo "<!-- before lclstr='$lclstr' -->\n";
	foreach ($EnglishMonths as $i => $monthEN) {
	   $lclstr = preg_replace('|'.$monthEN.'|i',$SITE['langMonths'][$i],$lclstr);
	}  
    echo "<!-- after lclstr='$lclstr' -->\n";
  }
  return ($lclstr);
}
// end of functions
//=========================================================================
?>