<?php
// Version 1.01 - 21-Nov-2023- fix notice errata when AQI data fetch fails - saratoga-weather.org
// Version 1.02 - 26-Jan-2024 - fix issues when feed is not available
//Current Air Quality URL
$urlRealtime = "http://feeds.enviroflash.info/rss/realtime/491.xml";  //  Tucson, AZ
// Images Directory
$imagesDir = "./ajax-images";

if (isset($_REQUEST['sce']) && ( strtolower($_REQUEST['sce']) == 'view' or
    strtolower($_REQUEST['sce']) == 'show') ) {
   //--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');

   readfile($filenameReal);
   exit;
}

// GET THE DATA FROM URL
$gotit = getAQIdata($urlRealtime, "realtime");


//// FUNCTIONS
// Data aquisition
function getAQIdata($AQIurl,$type) {
	global $$type;

	$$type = array();
	$typeA = $type;
	$typeA = new DOMDocument();
	$status = @$typeA->load($AQIurl);
	if($status == false) {
		return(false);
	}
	foreach ($typeA->getElementsByTagName('item') as $node) {
		$itemRSS = array ( 
			'title' => $node->getElementsByTagName('title')->item(0)->nodeValue,
			'desc' => $node->getElementsByTagName('description')->item(0)->nodeValue,
			);
		array_push($$type, $itemRSS);
	}
	return(true);
}	
if($gotit == false) { // oops.. no data to display
  global $realValue1;
  $realValue1 == "";
	return;
}

// strip out the needed data
preg_match('|<br /><br />\n(.*) - (.*) AQI - (.*)<br />\n|Uis', $realtime[0]["desc"], $r3);
$realIndex1 = 'N/A';
$realValue1 = 'N/A';
$realMeasure1 = 'N/A';

$realIndex2 = 'N/A';
$realValue2 = 'N/A';
$realMeasure2 = 'N/A';

// search for two AQI types
if(preg_match('|<br /><br />\n(.*) - (.*) AQI - (.*)<br />(.*) - (.*) AQI - (.*)</div>|Uis', $realtime[0]["desc"])) {
   preg_match('|<br /><br />\n(.*) - (.*) AQI - (.*)<br />(.*) - (.*) AQI - (.*)</div>|Uis', $realtime[0]["desc"], $r3);
   $realIndex2 = trim(strip_tags($r3[4]));
   $realValue2 = trim(strip_tags($r3[5]));
   $realMeasure2 = trim(strip_tags($r3[6]));
}

if(isset($r3[3])) {
  $realIndex1 = trim(strip_tags($r3[1]));
  $realValue1 = trim(strip_tags($r3[2]));
  $realMeasure1 = trim(strip_tags($r3[3]));
}

// get the last update
preg_match('|Last Update: (.*)</i>|', $realtime[0]["desc"], $r4);
$realUpdate = isset($r4[1])?trim(strip_tags($r4[1])):'N/A';

// arrays for comparing levels and values
$aqiValues = array('0-50', '51-100', '101-150', '151-200', '201-300', '301-500');
$aqiLevels = array('Good', 'Moderate', 'Unhealthy for Sensitive Groups', 'Unhealthy', 'Very Unhealthy', 'Hazardous');
//$aqiGraphic = array('aqi_good_text.gif', 'aqi_mod_text.gif', 'aqi_usg_text.gif', 'aqi_unh_text.gif', 'aqi_vunh_text.gif', 'aqi_haz_text.gif');  ////////////////////////////////////////////
$aqiGraphic = array('AQI1.jpg', 'AQI2.jpg', 'AQI3.jpg', 'AQI4.jpg', 'AQI5.jpg', 'AQI6.jpg');  ////////////////////////////////////////////


if ($realValue1) { 
   $dashbrdAQI = "<span style=\"font-size: 100%; color: black; font-weight:bold;\">" .$realValue1."</span>";
   $showGI = 1;    
}
else {
   $dashbrdAQI = "<span style=\"font-size: 100%; color: black;\">Data Not<br />Available</span>"; 
   $showGI = '';    
}


// Associate AQI level with graphic icon
function getGraphic($value, $levels, $graphic, $iDir) {
   global $levelImage;  // for front page
   
   $var = array_search($value, $levels);
   if($value !== 'N/A') {
   $levelImage = "<img src=\"".$iDir.$graphic["$var"]."\" width=\"45\" alt=\"  ".$levels["$var"]."\" title=\"".$levels["$var"]."\" />";
   echo $levelImage;
   }
   else {
   $levelImage = "<img src=\"".$iDir."aqi_nodata_text.gif\" alt=\"No Data\" title=\"No Data\" />";
   echo $levelImage;
   }
}

function getGraphic1($value, $levels, $graphic, $iDir) {
   global $levelImage1; // for cell phone   
   $var = array_search($value, $levels);
   if($value !== 'N/A') {
   $levelImage1 = "<img src=\"".$iDir.$graphic["$var"]."\" width=\"65\" alt=\"  ".$levels["$var"]."\" title=\"".$levels["$var"]."\" />";
   echo $levelImage1;
   }
   else {
   $levelImage = "<img src=\"".$iDir."aqi_nodata_text.gif\" alt=\"No Data\" title=\"No Data\" />";
   echo $levelImage1;
   }
}
	
////  END OF FUNCTIONS
?>
